// FlatMenuDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FlatMenu.h"
#include "FlatMenuDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFlatMenuDlg dialog

CFlatMenuDlg::CFlatMenuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFlatMenuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFlatMenuDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFlatMenuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFlatMenuDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFlatMenuDlg, CDialog)
	//{{AFX_MSG_MAP(CFlatMenuDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FLAT, OnFlat)
	ON_BN_CLICKED(IDC_UNFLAT, OnUnflat)
	ON_BN_CLICKED(IDC_SHADOW, OnShadow)
	ON_BN_CLICKED(IDC_NOSHADOW, OnNoshadow)
	ON_BN_CLICKED(IDC_WHITE, OnWhite)
	ON_BN_CLICKED(IDC_GRAY, OnGray)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFlatMenuDlg message handlers

BOOL CFlatMenuDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	if (strstr(GetCommandLine(), " -flatnoshadow"))
	{
		OnFlat();
		OnWhite();
		ExitProcess(1);
	}
	if (strstr(GetCommandLine(), " -flat"))
	{
		OnFlat();
		OnShadow();
		OnWhite();
		ExitProcess(1);
	}
	if (strstr(GetCommandLine(), " -noflat"))
	{
		OnUnflat();
		OnNoshadow();
		OnGray();
		ExitProcess(1);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFlatMenuDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFlatMenuDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFlatMenuDlg::OnFlat() 
{
	BOOL b = TRUE;
	SystemParametersInfo(SPI_SETFLATMENU, 0, (LPVOID) b, /*SPIF_UPDATEINIFILE |*/ SPIF_SENDCHANGE);
}

void CFlatMenuDlg::OnUnflat() 
{
	BOOL b = FALSE;
	SystemParametersInfo(SPI_SETFLATMENU, 0, (LPVOID) b, /*SPIF_UPDATEINIFILE |*/ SPIF_SENDCHANGE);
}

void CFlatMenuDlg::OnShadow() 
{
	BOOL b = TRUE;
	SystemParametersInfo(SPI_SETDROPSHADOW, 0, (LPVOID) b, /*SPIF_UPDATEINIFILE |*/ SPIF_SENDCHANGE);
}

void CFlatMenuDlg::OnNoshadow() 
{
	BOOL b = FALSE;
	SystemParametersInfo(SPI_SETDROPSHADOW, 0, (LPVOID) b, /*SPIF_UPDATEINIFILE |*/ SPIF_SENDCHANGE);
}

void CFlatMenuDlg::OnWhite() 
{
	int iElement[5];
	DWORD color[5];
	
	iElement[0] = COLOR_MENUBAR;
	//color[0] = 0x00F5F5F5;
	//color[0] = 0x00D6C7C8;   // mein blaugrau
	//color[0] = 0x00C8D0D4;   // standard win2k grau
	color[0] = GetSysColor(COLOR_3DFACE);   // 3d-grau

	iElement[1] = COLOR_MENU;
	//color[1] = 0x00FAF5F5;   // fast wei
	color[1] = 0x00FFFFFF;   // wei

	iElement[2] = COLOR_MENUHILIGHT;
	//color[2] = 0x00FAF5F5;  // wei (Hintergrund)
	//color[2] = 0x00F4C1AB;  // + 4%
	//color[2] = 0x00EBBAA5;  // wei ... 50% ... blau
	//color[2] = 0x00E49D7D;  // wei ... 75% ... blau
	color[2] = 0x00DD8055;  // blau (Highlight)

	iElement[3] = COLOR_HIGHLIGHT;
	color[3] = 0x00DD8055;

	iElement[4] = COLOR_HIGHLIGHTTEXT;
	//color[4] = 0x00000000;
	color[4] = 0x00FFFFFF;
	SetSysColors(5, iElement, color);
}

void CFlatMenuDlg::OnGray() 
{
	//DWORD x = GetSysColor(COLOR_HIGHLIGHTTEXT);

	int iElement[5];
	COLORREF color[5];
	
	iElement[0] = COLOR_MENUBAR;
	color[0] = 0x00D6C7C8;
	
	iElement[1] = COLOR_MENU;
	color[1] = 0x00D6C7C8;

	iElement[2] = COLOR_MENUHILIGHT;
	color[2] = 0x00DD8055;

	iElement[3] = COLOR_HIGHLIGHT;
	color[3] = 0x00DD8055;

	iElement[4] = COLOR_HIGHLIGHTTEXT;
	color[4] = 0x00FFFFFF;
	SetSysColors(5, iElement, color);
}
